import { Injectable } from '@angular/core';
import { assign, cloneDeep } from 'lodash-es';
import { FuseMockApiService, FuseMockApiUtils } from '@fuse/lib/mock-api';
import { evoSetting as evoSettingData } from './data';

@Injectable({
  providedIn: 'root',
})
export class EvoSettingMockApi {
  private _evoSetting: any = evoSettingData;

  /**
   * Constructor
   */
  constructor(private _fuseMockApiService: FuseMockApiService) {
    // Register Mock API handlers
    this.registerHandlers();
  }

  // -----------------------------------------------------------------------------------------------------
  // @ Public methods
  // -----------------------------------------------------------------------------------------------------

  /**
   * Register Mock API handlers
   */
  registerHandlers(): void {
    // -----------------------------------------------------------------------------------------------------
    // @ BasicSetting - GET
    // -----------------------------------------------------------------------------------------------------
    this._fuseMockApiService
      .onGet('api/apps/settings/evo', 300)
      .reply(({ request }) => {
        // Clone the deposits
        let evoSetting: any | null = cloneDeep(this._evoSetting);

        // Return the response
        return [
          200,
          {
            evoSetting,
          },
        ];
      });

    // -----------------------------------------------------------------------------------------------------
    // @ BasicSetting - PATCH
    // -----------------------------------------------------------------------------------------------------
    this._fuseMockApiService
      .onPatch('api/apps/settings/evo')
      .reply(({ request }) => {
        // Get the id and deposit
        const evoSetting = cloneDeep(request.body.evoSetting);

        // Prepare the updated basicSetting
        let updatedBasicSetting = null;

        // Find the deposit and update it
        // this._basicSetting.forEach((item, index, bs) => {
        //   if (item.id === id) {
        //     // Update the deposit
        //     basicSetting[index] = assign({}, basicSetting[index], deposit);

        //     // Store the updated deposit
        //     updatedDeposit = deposits[index];
        //   }
        // });

        // Return the response
        return [200, evoSetting];
      });
  }
}
